-- modle de bascule D avec specifications de timing fichier sdf
-- basd_mo1.vhd

library ieee,vital ;
use ieee.std_logic_1164.all ;
use vital.VITAL_Timing.all;

entity bascd_sdf is
   generic (
            tpd_hor_q : DelayType01 := (0 ns, 0 ns) ; -- retard
            tsetup_d_hor : DelayTypeXX := 0 ns ; -- prpositionnement > 0
            thold_d_hor : DelayTypeXX := 0 ns  ) ; -- maintien 
   port (   hor,d : in std_logic ;
            q : out std_logic ) ;
end bascd_sdf ;

library VITAL;
use VITAL.VITAL_Primitives.all;
use VITAL.VITAL_Timing.all;

architecture vital_prim22b of bascd_sdf is
begin
   bascule : process (d, hor)
   -- donnes
   -- tests de timings
   VARIABLE viol_regles : X01 := '0';
   VARIABLE temps_d : TimeMarkerType := (-500 ns,NULL,NULL);

   -- quations de fonctionnement : table de transitions
   VARIABLE anciens : STD_LOGIC_VECTOR(0 to 2) := (others => 'X');
   variable q_ideal : STD_LOGIC := 'X' ;

   CONSTANT transitions : VitalStateTableType (1 to 7, 1 to 5) := (
   --------------------------------
   --Viol  d   hor       q   :   q+
   --------------------------------
    ('X', '-', '-',     '-',    'X' ),-- erreur timing
    ('-', '1', '/',     '-',    '1' ),-- mise  1
    ('-', '0', '/',     '-',    '0' ),-- mise  0
    ('-', '-', '^',     '-',    'X' ),-- fronts d'horloges illgaux :
    ('-', '-', 'r',     '-',    'X' ),-- X->1 et O->X
    ('-', '-', 'F',     '-',    'S' ),-- fronts descendants
    ('-', '-', 'S',     '-',    'S' ) -- pas de front d'horloge
    );

   -- traitement de la sortie
   VARIABLE q_histoire : GlitchDataType ;
   begin
    -- contrle des rgles temporelles :
         VitalTimingCheck (
                        TestPort => d, 
                        TestPortName => "d",
                        RefPort => hor,
                        RefPortName => "hor",
                        t_setup_hi => tsetup_d_hor,
                        t_setup_lo => tsetup_d_hor,
                        t_hold_hi => thold_d_hor,
                        t_hold_lo => thold_d_hor,
                        CheckEnabled => TRUE,
                        RefTransition => hor = '1',
                        HeaderMsg => bascd_sdf'path_name,
                        TimeMarker => temps_d,
                        Violation => viol_regles);
    -- fonctionnement logique idal :
      VitalStateTable(
         StateTable => transitions,
         DataIn => (viol_regles, d, hor ),
         Result => q_ideal,
         PreviousDataIn => anciens);
    -- transaction avec retards :
      VitalPropagatePathDelay (
        OutSignal => q,
        OutSignalName => "q",
        OutTemp => q_ideal,
        Paths => (0 => (hor'last_event, VitalExtendToFillDelay(tpd_hor_q), TRUE)),
        GlitchData => q_histoire,
        GlitchMode => NoGlitch,
        GlitchKind => OnEvent);
end process;
end vital_prim22b ;

